import { yamlLanguage, yaml } from '@codemirror/lang-yaml';
import { ExternalTokenizer, LRParser, LocalTokenGroup } from '@lezer/lr';
import { styleTags, tags } from '@lezer/highlight';
import { indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LRLanguage, LanguageDescription, LanguageSupport } from '@codemirror/language';
import { parseMixed } from '@lezer/common';
import { MetaStore, RainLanguageServices, TextDocumentItem, CompletionItemKind } from '@rainlanguage/dotrain';
export * from '@rainlanguage/dotrain';
export { MetaStore } from '@rainlanguage/dotrain';
import { Facet } from '@codemirror/state';
import { autocompletion } from '@codemirror/autocomplete';
import { hoverTooltip, ViewPlugin } from '@codemirror/view';
import { setDiagnostics } from '@codemirror/lint';
import { TextDocument } from 'vscode-languageserver-textdocument';
export { TextDocument } from 'vscode-languageserver-textdocument';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const FrontMatter = 1;

const frontMatter = new ExternalTokenizer((input, _stack) => {
    // 45 = -
    // 47 = /
    // 42 = *
    while (input.next >= 0) {
        if (input.next == 45 && input.peek(1) == 45 && input.peek(2) == 45) {
            input.acceptToken(FrontMatter);
            break;
        }
        else if (input.next == 42 && input.peek(1) == 47) {
            break;
        }
        input.advance();
    }
});

const highlight = styleTags({
    FrontMatterSplitter: tags.comment,
    Number: tags.number,
    Placeholder: tags.unit,
    VariableName: tags.variableName,
    Opcode: tags.keyword,
    OpcodeWithOperand: tags.keyword,
    BlockComment: tags.comment,
    AngleBracketOpen: tags.keyword,
    AngleBracketClose: tags.keyword,
    ParenOpen: tags.keyword,
    ParenClose: tags.keyword,
    Assignment: tags.separator,
    Comma: tags.punctuation,
    Semi: tags.punctuation,
    Import: tags.meta,
    Binding: tags.className,
    Quote: tags.string,
    StringLiteral: tags.string,
    SubParser: tags.string,
    Pragma: tags.unit,
});
const indent = indentNodeProp.add({
    Expression: delimitedIndent({ closing: ")", align: false }),
});
const fold = foldNodeProp.add({
    Expression: foldInside,
    BlockComment(tree) { return { from: tree.from + 2, to: tree.to - 2 }; }
});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "$nQ!^QROOP!eOQOOO#eQQO'#CqOOQO'#Cn'#CnO#lQQO'#CmOOQO'#DQ'#DQOOQO'#Cw'#CwQ#sQQOOQ#sQQOOQYQQOOP#}OSO'#C^POOO)C>p)C>pOOQO'#Cx'#CxO$YQQO,59]O$aQQO,59]O$fQQO,59XOOQO,59X,59XOOQO-E6u-E6uPOOO'#Cv'#CvP$mOSO,58xPOOO,58x,58xOOQO-E6v-E6vO$xQQO1G.wOOQO1G.w1G.wOOQO1G.s1G.sPOOO-E6t-E6tPOOO1G.d1G.dOOQO7+$c7+$c",
  stateData: "%T~OoOSpPQ~OSWOTTOUTOVTOWTOXTOYTOZTO[TO]TO^TO_TOcROfQOhUOiUO~OPXO~PYOpYO~OTTOUTOVTOWTOXTOYTOZTO[TO]TO^TO_TOcROfQO~Og^O~P!jO``O~P!jOhUOiUO~P!jOqbOrbOsdO~OgfO~P!jOdgO~O`hO~P!jOqbOrbOsjO~OdkO~Ocf_f]~",
  goto: "#_uPPvPPPPPPPPPPPPPPy!TPP!_PPPP!i!o!wPPPPPPP#RRZPaTOQSVWX]_aSOQSVWX]_aROQSVWX]_QcYRicUVOWXRaVQ]QQ_STe]_WUOVWXX[QS]_",
  nodeNames: "⚠ FrontMatter BlockComment Program FrontMatterSplitter Semi Comma Assignment AngleBracketOpen Number StringLiteral SubParser Placeholder VariableName Quote Pragma ParenClose Expression OpcodeOpening Opcode ParenOpen OpcodeWithOperandOpening OpcodeWithOperand AngleBracketClose Import Binding",
  maxTerm: 36,
  propSources: [highlight,indent,fold],
  skippedNodes: [0,2,26],
  repeatNodeCount: 3,
  tokenData: "5z~RiXY!pYZ!p]^!ppq!prs#Rst#pwx$nxy%lyz%q|}%v}!O%{!P!Q&^!Q!R&i!R![']![!](P!]!^(U!^!_(Z!`!a(`!b!c(e!c!}*n!}#O+a#R#S,R#T#i*n#i#j,W#j#o*n~!uSo~XY!pYZ!p]^!ppq!p~#UTOr#Rrs#es;'S#R;'S;=`#j<%lO#R~#jOY~~#mP;=`<%l#R~#uZi~OX#pZ]#p^p#pqx#pz|#p}![#p!_!`#p!a#Q#p#R;'S#p;'S;=`$h<%lO#p~$kP;=`<%l#p~$sZ^~OX$nZ]$n^p$nqx$nz|$n}![$n!_!`$n!a#Q$n#R;'S$n;'S;=`%f<%lO$n~%iP;=`<%l$n~%qOd~~%vO`~~%{OU~~&OP}!O&R~&UP}!O&X~&^OS~~&aPz{&d~&iOp~~&nPX~#l#m&q~&tR!Q![&}!c!i&}#T#Z&}~'SRX~!Q![&}!c!i&}#T#Z&}~'bQX~!Q!['h#X#Y'q~'kQ!Q!['h#X#Y'q~'tP!Q!['w~'|PX~!Q!['w~(UOV~~(ZOT~~(`OW~~(eOg~~(hVXY(eYZ(e]^(epq(e!Q!R(}!c!})o#T#o)o~)QP#l#m)T~)WR!Q![)a!c!i)a#T#Z)a~)fRh~!Q![)a!c!i)a#T#Z)a~)rWXY*[YZ*[]^*[pq*[}!O)o!Q![)o!c!})o#T#o)o~*_TXY*[YZ*[]^*[pq*[!Q!R(}~*sU]~xy+V}!O*n!Q![*n!^!_+[!c!}*n#T#o*n~+[Oc~~+aOf~~+dUO!}+a#O#P+a#P#Q+v#Q;'S+a;'S;=`+{<%lO+a~+{OZ~~,OP;=`<%l+a~,WO[~~,]W]~xy+V}!O*n!Q![*n!^!_+[!c!}*n#T#g*n#g#h,u#h#o*n~,zW]~xy+V}!O*n!Q![*n!^!_+[!c!}*n#T#]*n#]#^-d#^#o*n~-iW]~xy+V}!O*n!Q![*n!^!_+[!c!}*n#T#b*n#b#c.R#c#o*n~.WW]~xy+V}!O*n!Q![*n!^!_+[!c!}*n#T#Z*n#Z#[.p#[#o*n~.uU]~xy+V}!O/X!Q![*n!^!_+[!c!}*n#T#o*n~/^W]~xy+V}!O*n!Q![*n!^!_+[!c!}*n#T#k*n#k#l/v#l#o*n~/{W]~xy+V}!O*n!Q![*n!^!_+[!c!}*n#T#c*n#c#d0e#d#o*n~0jW]~xy+V}!O*n!Q![*n!^!_+[!c!}*n#T#f*n#f#g1S#g#o*n~1XW]~xy+V}!O*n!Q![*n!^!_+[!c!}*n#T#W*n#W#X1q#X#o*n~1vW]~xy+V}!O*n!Q![*n!^!_+[!c!}*n#T#g*n#g#h2`#h#o*n~2eU]~xy+V}!O2w!Q![*n!^!_+[!c!}*n#T#o*n~2|W]~xy+V}!O*n!Q![*n!^!_+[!c!}*n#T#Y*n#Y#Z3f#Z#o*n~3kW]~xy+V}!O*n!Q![*n!^!_+[!c!}*n#T#f*n#f#g4T#g#o*n~4YW]~xy+V}!O*n!Q![*n!^!_+[!c!}*n#T#c*n#c#d4r#d#o*n~4wW]~xy+V}!O*n!Q![*n!^!_+[!c!}*n#T#a*n#a#b5a#b#o*n~5hU_~]~xy+V}!O*n!Q![*n!^!_+[!c!}*n#T#o*n",
  tokenizers: [frontMatter, 1, new LocalTokenGroup("u~RRYZ[]^az{i~aOr~~fPr~YZ[~lP!P!Qo~tOs~~", 36, 33)],
  topRules: {"Program":[0,3]},
  tokenPrec: 183
});

/**
 * @public Rainlang syntax highlighter
 */
const RainlangLR = LRLanguage.define({
    name: "rainlang",
    parser: parser.configure({
        wrap: parseMixed((node, _input) => node.type.id == FrontMatter
            ? { parser: yamlLanguage.parser, overlay: [{ from: node.from, to: node.to }] }
            : null)
    }),
    languageData: {
        closeBrackets: { brackets: ["(", "<", "["] },
        commentTokens: { block: { open: "/*", close: "*/" } }
    }
});

/**
 * @public Converts TextDocument to TextDocumentItem
 */
function toTextDocumentItem(textDocument) {
    return {
        text: textDocument.getText(),
        uri: textDocument.uri,
        version: textDocument.version,
        languageId: textDocument.languageId
    };
}
// const useLast = (values: readonly any[]) => values.reduce((_, v) => v, '');
// const documentUri = Facet.define<string, string>({ combine: useLast });
// const languageId = Facet.define<string, string>({ combine: useLast });
/**
 * @public A plugin that manages languages services processes.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 */
class RainLanguageServicesPlugin {
    view;
    callback;
    uri = "file:///untitled.rain";
    languageId = "rainlang";
    metaStore;
    version = 0;
    langServices;
    textDocument;
    /**
     * @public constructor of the class
     * @param view - The editor view instance
     * @param metaStore - (optional) The meta store object to use
     * @param callback - (optional) The callback to run fork calls on native parser,
     * this will be called everytime there are no active diagnostics, so as a result,
     * errors from calling onchain parser will be shown as diagnostics
     */
    constructor(view, metaStore, callback) {
        this.view = view;
        this.callback = callback;
        this.metaStore = metaStore ? metaStore : new MetaStore(true);
        this.textDocument = TextDocument.create(this.uri, this.languageId, this.version, this.view.state.doc.toString());
        this.langServices = new RainLanguageServices(this.metaStore);
        this.processDiagnostics(this.view.state.doc.toString(), this.version).then(v => this.view.dispatch(v[0]));
    }
    // update the instance of TexTdocument and RainDocument
    update(update) {
        if (!update.docChanged)
            return;
        else {
            TextDocument.update(this.textDocument, [{ text: this.view.state.doc.toString() }], ++this.version);
            this.processDiagnostics(this.view.state.doc.toString(), this.version).then(v => v[1] === this.version ? this.view.dispatch(v[0]) : {});
        }
    }
    destroy() { }
    /**
     * @public Handles calls for hover tooltip
     */
    async handleHoverTooltip(offset) {
        try {
            const hover = this.langServices.doHover(toTextDocumentItem(this.textDocument), this.textDocument.positionAt(offset));
            if (!hover)
                return null;
            else {
                let end;
                if (hover.range) {
                    offset = this.textDocument.offsetAt(hover.range.start);
                    end = this.textDocument.offsetAt(hover.range.end);
                }
                return getHoverTooltip(hover, offset, end);
            }
        }
        catch (err) {
            console.log(err);
            return null;
        }
    }
    /**
     * @public Handles calls for code completion
     */
    async handleCompletion(context) {
        try {
            const completions = this.langServices.doComplete(toTextDocumentItem(this.textDocument), this.textDocument.positionAt(context.pos));
            if (!completions)
                return null;
            else
                return getCompletion(context, completions);
        }
        catch (err) {
            console.log(err);
            return null;
        }
    }
    /**
     * @public Handles calls for docuement diagnostics
     */
    async processDiagnostics(text, version) {
        try {
            const textDocument = TextDocumentItem.create("file:///temp.rain", "rainlang", 0, text);
            const rainDocument = this.langServices.newRainDocument(textDocument);
            const diagnostics = getDiagnostics(rainDocument.allProblems);
            if (diagnostics.length === 0 && this.callback) {
                const npErrors = await this.callback(rainDocument);
                return [setDiagnostics(this.view.state, getDiagnostics(npErrors)), version];
            }
            else {
                return [setDiagnostics(this.view.state, diagnostics), version];
            }
        }
        catch (err) {
            console.log(err);
            return [setDiagnostics(this.view.state, []), version];
        }
    }
}
/**
 * @public A plugin that gets all lang services through provided callbacks.
 * So all the logic behind suppliying the lang services results can be out-sources
 * on the callbacks implementations.
 * Each callback is triggered when the services is on demand in the text editor
 * through use input/actions
 */
class RawRainLanguageServicesPlugin {
    view;
    callbacks;
    uri = "file:///untitled.rain";
    languageId = "rainlang";
    version = 0;
    textDocument;
    constructor(view, callbacks) {
        this.view = view;
        this.callbacks = callbacks;
        this.textDocument = TextDocument.create(this.uri, this.languageId, this.version, this.view.state.doc.toString());
        this.processDiagnostics(this.view.state.doc.toString(), this.version).then(v => this.view.dispatch(v[0]));
    }
    // update the instance of TexTdocument and RainDocument
    update(update) {
        if (!update.docChanged)
            return;
        else {
            TextDocument.update(this.textDocument, [{ text: this.view.state.doc.toString() }], ++this.version);
            this.processDiagnostics(this.view.state.doc.toString(), this.version).then(v => v[1] === this.version ? this.view.dispatch(v[0]) : {});
        }
    }
    destroy() { }
    /**
     * @public Handles calls for hover tooltip
     */
    async handleHoverTooltip(offset) {
        if (this.callbacks.hover) {
            try {
                const hover = await this.callbacks.hover(toTextDocumentItem(this.textDocument), this.textDocument.positionAt(offset));
                if (!hover)
                    return null;
                else {
                    let end;
                    if (hover.range) {
                        offset = this.textDocument.offsetAt(hover.range.start);
                        end = this.textDocument.offsetAt(hover.range.end);
                    }
                    return getHoverTooltip(hover, offset, end);
                }
            }
            catch (err) {
                console.log(err);
                return null;
            }
        }
        else
            return null;
    }
    /**
     * @public Handles calls for code completion
     */
    async handleCompletion(context) {
        if (this.callbacks.completion) {
            try {
                const completions = await this.callbacks.completion(toTextDocumentItem(this.textDocument), this.textDocument.positionAt(context.pos));
                if (!completions)
                    return null;
                else
                    return getCompletion(context, completions);
            }
            catch (err) {
                console.log(err);
                return null;
            }
        }
        else
            return null;
    }
    /**
     * @public Handles calls for docuement diagnostics
     */
    async processDiagnostics(text, version) {
        try {
            const textDocument = TextDocumentItem.create("file:///temp.rain", "rainlang", 0, text);
            const diagnostics = await this.callbacks.diagnostics(textDocument);
            return [setDiagnostics(this.view.state, getDiagnostics(diagnostics)), version];
        }
        catch (err) {
            console.log(err);
            return [setDiagnostics(this.view.state, []), version];
        }
    }
}
/**
 * @public Converts LSP hover to codemirror hover tooltips.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 *
 * @param hover - The LSP hover item
 * @param pos - Offset of the textDocument to get the completion items for
 * @param end - The end offset of the requested hiver item
 * @returns Codemirror tooltip or null
 */
function getHoverTooltip(hover, pos, end) {
    const { contents } = hover;
    if (pos === null)
        return null;
    const dom = document.createElement("div");
    dom.classList.add("documentation");
    //if (this.allowHTMLContent) dom.innerHTML = formatContents(contents);
    //else 
    dom.textContent = contents.value;
    return { pos, end, create: (_view) => ({ dom }), above: true };
}
/**
 * @public Converts LSP CompletionItem to codemirror code completions.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 *
 * @param context - Completion context
 * @param completionItems - The LSP completion items
 * @returns Codemirror completion result or null
 */
function getCompletion(context, completionItems) {
    const CompletionItemKindMap = Object.fromEntries(Object.entries(CompletionItemKind).map(([key, value]) => [value, key]));
    let { pos } = context;
    if (!context.matchBefore(/['\w-]+$/))
        return null;
    let completions = completionItems.map(({ detail, label, kind, insertText, documentation, sortText, filterText, }) => {
        const completion = {
            label,
            detail,
            apply: (view, _comp) => {
                // re adjusting the cursor position for opcodes
                const matcher = prefixMatch([_comp]);
                const match = context.matchBefore(matcher[1]);
                if (insertText) {
                    let cursorPos = match.from + insertText.length;
                    if (insertText.includes("<>"))
                        cursorPos -= 2;
                    view.dispatch({
                        changes: {
                            from: match.from,
                            to: match.to,
                            insert: insertText
                        },
                        selection: { anchor: cursorPos, head: cursorPos }
                    });
                }
                else
                    view.dispatch({
                        changes: {
                            from: match.from,
                            to: match.to,
                            insert: label
                        }
                    });
            },
            type: kind && CompletionItemKindMap[kind].toLowerCase(),
            sortText: sortText ?? label,
            filterText: filterText ?? label,
        };
        if (documentation) {
            completion.info = documentation.value;
        }
        return completion;
    });
    const [_span, _match] = prefixMatch(completions);
    const token = context.matchBefore(_match);
    if (token) {
        pos = token.from;
        const word = token.text.toLowerCase();
        if (/^['\w-]+$/.test(word)) {
            completions = completions
                .filter(({ filterText }) => filterText.toLowerCase().startsWith(word))
                .sort(({ label: a }, { label: b }) => {
                switch (true) {
                    case a.startsWith(token.text) && !b.startsWith(token.text):
                        return -1;
                    case !a.startsWith(token.text) && b.startsWith(token.text):
                        return 1;
                }
                return 0;
            });
        }
    }
    return {
        from: pos,
        options: completions,
    };
}
/**
 * @public Converts RainDocument Problems to codemirror diagnostics
 * @param problems - RainDocument problems
 */
function getDiagnostics(problems) {
    return problems.map(({ msg, position }) => ({
        message: msg,
        from: position[0],
        to: position[1],
        severity: "error"
        // ({
        //     [DiagnosticSeverity.Error]: "error",
        //     [DiagnosticSeverity.Warning]: "warning",
        //     [DiagnosticSeverity.Information]: "info",
        //     [DiagnosticSeverity.Hint]: "info",
        // } as const)[severity!]
    }));
}
/**
 * @public Converts a position to offset of a character in a codemirror text.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 *
 * @param doc - Codemirror text
 * @param pos - The position to convert
 * @returns - The offset of the provided position
 */
function posToOffset(doc, pos) {
    if (pos.line >= doc.lines)
        return doc.length;
    const offset = doc.line(pos.line + 1).from + pos.character;
    if (offset > doc.length)
        return doc.length;
    return offset;
}
/**
 * @public Converts offset of a character in a codemirror text to a position.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 *
 * @param doc - Codemirror text
 * @param offset - The offset to convert
 * @returns - The position of the provided character offset
 */
function offsetToPos(doc, offset) {
    const line = doc.lineAt(offset);
    return {
        line: line.number - 1,
        character: offset - line.from,
    };
}
/**
 * @public Constructs regexp out of completion items.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 *
 * @param completions - Codemirror completion items
 * @returns Regexp of completion items
 */
function prefixMatch(completions) {
    function toSet(chars) {
        let preamble = "";
        let flat = Array.from(chars).join("");
        const words = /\w/.test(flat);
        if (words) {
            preamble += "\\w";
            flat = flat.replace(/\w/g, "");
        }
        return `[${preamble}${flat.replace(/[^\w\s]/g, "\\$&")}]`;
    }
    const first = new Set();
    const rest = new Set();
    for (const { label } of completions) {
        const [initial, ...restStr] = label;
        first.add(initial);
        for (const char of restStr) {
            rest.add(char);
        }
    }
    const source = toSet(first) + toSet(rest) + "*$";
    return [new RegExp("^" + source), new RegExp(source)];
}
/**
 * @public Reduces an array to its last element
 * @param values - Values to reduce
 */
const useLast = (values) => values.reduce((_, v) => v, "");

/**
 * @public The facet used to store and retrive RainLanguageServicesPlugin instance from a EditorView.plugin().
 * By getting the facet value from the state associated with that EditoreView instance, you then can intract
 * with the plugin directly to get the Meta.Store instance and update its subgraph and metas manually, however,
 * this is not recommended as the meta storage and management is handled automatically by every meta hash that
 * is specified in an Rain document, so using this will not be needed in most of the cases unless some custom
 * behavior is intended.
 * This combination is provided for `rainlang` LanguageSupport class object and not for `RainlangExtention` class.
 *
 * @example
 * ```typescript
 * // get value of the facet
 * const rainViewPlugin = editorView.state.facet(RainLanguageServicesFacet);
 *
 * // get the plugin instance
 * const rainPlugin = editorView.plugin(rainViewPlugin);
 *
 * // update op meta from plugin
 * rainPlugin.getMetaStore();
 * ```
 */
const RainLanguageServicesFacet = Facet.define({ combine: useLast });
/**
 * @public Rainlang as a codemirror extension
 * @example
 * ```typescript
 * // instantiate the extension that can be directly used as codemirror extension
 * const rainlangExtension = new RainlangExtention(options);
 *
 * // instantiate the extension with initial meta data
 * const rainlangExtension = new RainlangExtension();
 *
 * // to get the MetaStore instance of this extension instance
 * const metaStore = rainlangExtension.plugin.metaStore;
 * ```
 */
class RainlangExtension extends LanguageSupport {
    plugin;
    hover = hoverTooltip((_view, pos) => this.plugin?.handleHoverTooltip(pos) ?? null);
    completion = autocompletion({
        override: [
            async (context) => {
                if (this.plugin == null)
                    return null;
                return await this.plugin?.handleCompletion(context);
            },
        ],
    });
    /**
     * @public Constructor of the RainlangCodemirror class
     * @param config - Options for language services to include
     */
    constructor(config) {
        const rainViewPlugin = ViewPlugin.define(view => this.plugin = new RainLanguageServicesPlugin(view, config?.metaStore, config?.callback));
        const ext = [
            yaml().support,
            RainLanguageServicesFacet.of(rainViewPlugin),
            rainViewPlugin
        ];
        super(RainlangLR, ext);
        if (!config)
            ext.push(this.hover, this.completion);
        else {
            if (config?.hover)
                ext.push(this.hover);
            if (config?.completion)
                ext.push(this.completion);
        }
    }
}
/**
 * @public Raw Rainlang codemirror extension, that does everything through supplied callbacks
 */
class RawRainlangExtension extends LanguageSupport {
    plugin;
    hover = hoverTooltip((_view, pos) => this.plugin?.handleHoverTooltip(pos) ?? null);
    completion = autocompletion({
        override: [
            async (context) => {
                if (this.plugin == null)
                    return null;
                return await this.plugin?.handleCompletion(context);
            },
        ],
    });
    /**
     * @public Constructor of the RainlangCodemirror class
     * @param callbacks - Raw language services callbacks
     */
    constructor(callbacks) {
        const rainViewPlugin = ViewPlugin.define(view => this.plugin = new RawRainLanguageServicesPlugin(view, callbacks));
        const ext = [
            yaml().support,
            RainLanguageServicesFacet.of(rainViewPlugin),
            rainViewPlugin
        ];
        super(RainlangLR, ext);
        if (callbacks.hover)
            ext.push(this.hover);
        if (callbacks.completion)
            ext.push(this.completion);
    }
}
/**
 * @public
 * Provides Rainlang implementation for codemirror as LanguageSupport
 * This is the standard implementation of rainlang for codemirror.
 *
 * @example
 * ```typescript
 * const rainLanguageSupport = RainLanguageSupport(config);
 * ```
 * in order to get the Meta.Store instance, it should be done through getting the plugin instance
 * from the EditorView with providing it the result of getting the `RainLanguageServicesFacet`
 * facet and then calling `getMetaStore()` for it, however this is not recommended as meta management
 * is done automatically from specified meta hashes in a Rain document:
 * ```typescript
 * // get the `RainLanguageServicesFacet` value from editor view
 * const rainViewPlugin = view.state.facet(RainLanguageServicesFacet);
 *
 * // retrive the `RainLanguageServicesPlugin` instance
 * const rainPlugin = view.plugin(rainViewPlugin);
 *
 * // get the Meta.Store instance
 * rainPlugin.metaStore();
 * ```
 *
 * @param config - Options for language services to include
 * @param metaStore - (optional) The meta store object to use
 * @returns rainlang LanguageSupport
 */
function RainLanguageSupport(config) {
    let plugin;
    const rainViewPlugin = ViewPlugin.define(view => plugin = new RainLanguageServicesPlugin(view, config?.metaStore, config?.callback));
    const services = [];
    const hover = hoverTooltip((_view, pos) => plugin?.handleHoverTooltip(pos) ?? null);
    const completion = autocompletion({
        override: [
            async (context) => {
                if (plugin == null)
                    return null;
                return await plugin?.handleCompletion(context);
            },
        ],
    });
    if (!config)
        services.push(hover, completion);
    else {
        if (config?.hover)
            services.push(hover);
        if (config?.completion)
            services.push(completion);
    }
    return new LanguageSupport(RainlangLR, [
        RainLanguageServicesFacet.of(rainViewPlugin),
        rainViewPlugin,
        yaml().support,
        ...services
    ]);
}
/**
 * @public Provides LanguageDescription class object for rainlang.
 * Use `load` to instantiate rain LanguageSupport with initial meta data
 */
const RainlangDescription = LanguageDescription.of({
    name: "rainlang",
    alias: ["Rain Language", "Rainlang", "RainLang", "rain"],
    extensions: [".rain"],
    load: (config) => {
        return Promise.resolve(new RainlangExtension(config));
    },
    support: new RainlangExtension()
});

export { RainLanguageServicesFacet, RainLanguageServicesPlugin, RainLanguageSupport, RainlangDescription, RainlangExtension, RainlangLR, RawRainLanguageServicesPlugin, RawRainlangExtension, getCompletion, getDiagnostics, getHoverTooltip, offsetToPos, posToOffset, prefixMatch, toTextDocumentItem, useLast };
